/*
keylight by pps
started: 22.07.2025
*/

;	@com.wudsn.ide.asm.hardware=ATARI8BIT

	icl 'atari.hea'

BEGIN	equ $2000				;start address

;----------
	.zpvar	.byte	regA,regX,regY
;----------
; ---	MAIN PROGRAM
	org BEGIN
	.proc ant
:3	.he 70
	.he 46
	.wo scr_title
	.he 70
;--- keyboard + colors
	.rept 6, #
;---
	.he 10 80

	.he 4f
	.wo scr_16c+(#*40)
	.he 4f
	.wo scr_16g+(#*40)
	
	.he 4f
	.wo scr_16c+(#*40)
	.he 4f
	.wo scr_16g+(#*40)
	.he 4f
	.wo scr_16c+(#*40)
	
	.he 80 42
	.wo scr_keys+(#*40)
;---
	.endr
;--- input area
	.he 80 70 42
	.wo scr_input
	.he 10
:6	.he 02
;---
	.he 41
	.wo ant
	.endp
;------------
	.proc main
	mva #0 559
	mwa #ant 560
	lda #7			;VBI
	ldx >vbi		;wird
	ldy <vbi		;jetzt
	jsr setvbv		;initialisiert
	mva #$c0 nmien		;DLI + VBI an
	mva #34 559

	jmp *
	.endp
;------------
	.proc vbi
	mwa #dli 512
	mva #@dmactl(standard|dma) dmactl	;set new screen width
	mva #0 colbak
	sta color2
	mva #$e color1
	mva #$e0 chbase
	jmp xitvbv
	.endp
;------------
;---line0
	.proc dli
	sta rega

	sta wsync
	.rept 2
	mva #6 colbak
	mva #@gtictl(mode11|prior1) gtictl
	sta wsync
	mva #0 colbak
	mva #@gtictl(mode9|prior1) gtictl
	sta wsync
	.endr
	mva #6 colbak
	mva #@gtictl(mode11|prior1) gtictl
	sta wsync
	mva #0 colbak

	mwa #dli1 512
	lda rega
	rti
	.endp
;------------
	.proc dli1
	sta rega

	mva #0 colbak
	mva #@gtictl(prior1) gtictl
	mva >fnt chbase
	sta wsync

	mwa #dli2 512
	lda rega
	rti
	.endp
;------------
;---line1
	.proc dli2
	sta rega

	sta wsync
	.rept 2
	mva #6 colbak
	mva #@gtictl(mode11|prior1) gtictl
	sta wsync
	mva #0 colbak
	mva #@gtictl(mode9|prior1) gtictl
	sta wsync
	.endr
	mva #6 colbak
	mva #@gtictl(mode11|prior1) gtictl
	sta wsync
	mva #0 colbak

	mwa #dli3 512
	lda rega
	rti
	.endp
;------------
	.proc dli3
	sta rega

	mva #0 colbak
	mva #@gtictl(prior1) gtictl
	mva >fnt chbase
	sta wsync

	mwa #dli4 512
	lda rega
	rti
	.endp
;------------
;---line2
	.proc dli4
	sta rega

	sta wsync
	.rept 2
	mva #6 colbak
	mva #@gtictl(mode11|prior1) gtictl
	sta wsync
	mva #0 colbak
	mva #@gtictl(mode9|prior1) gtictl
	sta wsync
	.endr
	mva #6 colbak
	mva #@gtictl(mode11|prior1) gtictl
	sta wsync
	mva #0 colbak

	mwa #dli5 512
	lda rega
	rti
	.endp
;------------
	.proc dli5
	sta rega

	mva #0 colbak
	mva #@gtictl(prior1) gtictl
	mva >fnt chbase
	sta wsync

	mwa #dli6 512
	lda rega
	rti
	.endp
;------------
;---line3
	.proc dli6
	sta rega

	sta wsync
	.rept 2
	mva #6 colbak
	mva #@gtictl(mode11|prior1) gtictl
	sta wsync
	mva #0 colbak
	mva #@gtictl(mode9|prior1) gtictl
	sta wsync
	.endr
	mva #6 colbak
	mva #@gtictl(mode11|prior1) gtictl
	sta wsync
	mva #0 colbak

	mwa #dli7 512
	lda rega
	rti
	.endp
;------------
	.proc dli7
	sta rega

	mva #0 colbak
	mva #@gtictl(prior1) gtictl
	mva >fnt chbase
	sta wsync

	mwa #dli8 512
	lda rega
	rti
	.endp
;------------
;---line4
	.proc dli8
	sta rega

	sta wsync
	.rept 2
	mva #6 colbak
	mva #@gtictl(mode11|prior1) gtictl
	sta wsync
	mva #0 colbak
	mva #@gtictl(mode9|prior1) gtictl
	sta wsync
	.endr
	mva #6 colbak
	mva #@gtictl(mode11|prior1) gtictl
	sta wsync
	mva #0 colbak

	mwa #dli9 512
	lda rega
	rti
	.endp
;------------
	.proc dli9
	sta rega

	mva #0 colbak
	mva #@gtictl(prior1) gtictl
	mva >fnt chbase
	sta wsync

	mwa #dli10 512
	lda rega
	rti
	.endp
;------------
;---line5
	.proc dli10
	sta rega

	sta wsync
	.rept 2
	mva #6 colbak
	mva #@gtictl(mode11|prior1) gtictl
	sta wsync
	mva #0 colbak
	mva #@gtictl(mode9|prior1) gtictl
	sta wsync
	.endr
	mva #6 colbak
	mva #@gtictl(mode11|prior1) gtictl
	sta wsync
	mva #0 colbak

	mwa #dli11 512
	lda rega
	rti
	.endp
;------------
	.proc dli11
	sta rega

	mva #0 colbak
	mva #@gtictl(prior1) gtictl
	mva >fnt chbase
	sta wsync

	mwa #dli_input 512
	lda rega
	rti
	.endp
;------------
	.proc dli_input
	sta rega

	mva #$e0 chbase
	sta wsync

	mwa #dli 512
	lda rega
	rti
	.endp
;------------
	.proc scr_keys
	ins "gfx/keylight.scr"
	.endp
;------------
	.proc scr_16g
;--- line 0
:17	.he 00
help	.he 22
:3	.he 00
start	.he 44
:3	.he 00
select	.he 66
:3	.he 00
option	.he 44
:3	.he 00
reset	.he aa
:6	.he 00
;--- line 1
:5	.he 00
esc	.he 88
	.he 00
one	.he 66
	.he 00
two	.he 44
	.he 00
three	.he 66
	.he 00
four	.he 22
	.he 00
fife	.he 66
	.he 00
six	.he 66
	.he 00
seven	.he 66
	.he 00
eight	.he 66
	.he 00
nine	.he 66
	.he 00
zero	.he 66
	.he 00
bleft	.he 66
	.he 00
bright	.he 66
	.he 00
delete	.he 66
:2	.he 00
break	.he 66
:5	.he 00
;--- line 2
:6	.he 00
tab	.he 88
	.he 00
q	.he 66
	.he 00
w	.he 44
	.he 00
e	.he 66
	.he 00
r	.he 22
	.he 00
t	.he 66
	.he 00
y	.he 66
	.he 00
u	.he 66
	.he 00
i	.he 66
	.he 00
o	.he 66
	.he 00
p	.he 66
	.he 00
minus	.he 66
	.he 00
even	.he 66
:2	.he 00
return	.he 66
:6	.he 00
;--- line 3
:6	.he 00
control	.he 11
:2	.he 00
a	.he 22
	.he 00
s	.he 33
	.he 00
d	.he 44
	.he 00
f	.he 55
	.he 00
g	.he 66
	.he 00
h	.he 77
	.he 00
j	.he 88
	.he 00
k	.he 99
	.he 00
l	.he aa
	.he 00
semi	.he bb
	.he 00
plus	.he cc
	.he 00
mul	.he dd
:2	.he 00
caps	.he ee
:6	.he 00
;--- line 4
:5	.he 00
lshift	.he ff
:3	.he 00
z	.he ee
	.he 00
x	.he 44
	.he 00
c	.he 55
	.he 00
v	.he 66
	.he 00
b	.he 77
	.he 00
n	.he 88
	.he 00
m	.he 99
	.he 00
komma	.he aa
	.he 00
dot	.he bb
	.he 00
slash	.he cc
:2	.he 00
rshift	.he ff
:2	.he 00
inv	.he dd
:8	.he 00
;--- line 5
:9	.he 00
space1	.he 44
:6	.he 00
space2	.he 44
:6	.he 00
space3	.he 44
:18	.he 00
	.endp
;------------
	.proc scr_16c
;--- line 0
:17	.he 00
help	.he 22	;red
:3	.he 00
start	.he bb	;green
:3	.he 00
select	.he 88	;blue
:3	.he 00
option	.he 44	;purple
:3	.he 00
reset	.he ee	;yellow
:6	.he 00
;--- line 1
:5	.he 00
esc	.he 88
	.he 00
one	.he 66
	.he 00
two	.he 44
	.he 00
three	.he 11
	.he 00
four	.he 22
	.he 00
fife	.he ff
	.he 00
six	.he 77
	.he 00
seven	.he cc
	.he 00
eight	.he 33
	.he 00
nine	.he 22
	.he 00
zero	.he 88
	.he 00
bleft	.he dd
	.he 00
bright	.he 99
	.he 00
delete	.he ee
:2	.he 00
break	.he 66
:5	.he 00
;--- line 2
:6	.he 00
tab	.he 11
	.he 00
q	.he 22
	.he 00
w	.he 00
	.he 00
e	.he 33
	.he 00
r	.he 44
	.he 00
t	.he 55
	.he 00
y	.he 66
	.he 00
u	.he 77
	.he 00
i	.he 88
	.he 00
o	.he 99
	.he 00
p	.he aa
	.he 00
minus	.he bb
	.he 00
even	.he cc
:2	.he 00
return	.he dd
:6	.he 00
;--- line 3
:6	.he 00
control	.he 11
:2	.he 00
a	.he 44
	.he 00
s	.he aa
	.he 00
d	.he bb
	.he 00
f	.he cc
	.he 00
g	.he dd
	.he 00
h	.he ee
	.he 00
j	.he ff
	.he 00
k	.he 99
	.he 00
l	.he 88
	.he 00
semi	.he 77
	.he 00
plus	.he 66
	.he 00
mul	.he 55
:2	.he 00
caps	.he 44
:6	.he 00
;--- line 4
:5	.he 00
lshift	.he ff
:3	.he 00
z	.he ee
	.he 00
x	.he 44
	.he 00
c	.he 55
	.he 00
v	.he 66
	.he 00
b	.he 77
	.he 00
n	.he 88
	.he 00
m	.he 99
	.he 00
komma	.he aa
	.he 00
dot	.he bb
	.he 00
slash	.he cc
:2	.he 00
rshift	.he ff
:2	.he 00
inv	.he dd
:8	.he 00
;--- line 5
:9	.he 00
space1	.he ee
:6	.he 00
space2	.he 44
:6	.he 00
space3	.he 22
:18	.he 00
	.endp
;------------
	.proc scr_title
	dta "set keyboard colors "
	.endp
;------------
	.proc scr_input
	dta "       press key to change color        "
:6	dta "0123456789012345678901234567890123456789"
	.endp
;------------
	.align $0400
	.proc fnt
	ins "gfx/keylight.fnt"
	.endp
;------------
	run main